#include "stdafx.h"
#include "SQLiteWrappers.h"


int SQLITE_CALLBACK TraceCallback(unsigned, void*, void*, void*) noexcept
{
  return 0;
}

int SQLITE_CALLBACK AuthorizerCallback(void*, int, const char*, const char*, const char*, const char*) noexcept
{
  return 0;
}

void SQLITE_CALLBACK DestructorCallback(void*) noexcept
{
}

int _tmain()
{
  SQLite3::CDB db;
  int nRet{db.Open("Database.db")}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
  assert(nRet == SQLITE_OK);
  SQLite3::CDB db2{db.Detach(), true};
  SQLite3::CDB db3;
  nRet = db.Open("Database.db", SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, nullptr);//NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
  SQLite3::CDB db4{db.Detach(), false};
  db4.Close();
  SQLite3::CDB db6;
  nRet = db6.Open("Database3.db"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
  db6.Closev2();
  nRet = db.Open16(L"Database2.db"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
__if_exists(SQLite3::CDB::Trace)
{
  db.Trace(SQLITE_TRACE_STMT, TraceCallback, nullptr);
} //__if_exists(SQLite3::CDB::Trace)
__if_exists(SQLite3::CDB::SetAuthorizer)
{
  db.SetAuthorizer(AuthorizerCallback, nullptr);
} //__if_exists(SQLite3::CDB::SetAuthorizer)
  db.Exec("CREATE TABLE a (b INTEGER, c INTEGER);");
  nRet = db.Exec("INSERT INTO a VALUES(1, 2);"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
  nRet = db.Exec("INSERT INTO a VALUES(3, 4);"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
  int nValue{db.Changes()}; //NOLINT(clang-analyzer-deadcode.DeadStores)
  sqlite3_int64 nnValue{db.Changes64()}; //NOLINT(clang-analyzer-deadcode.DeadStores)
  nnValue = db.LastInsertRowID(); //NOLINT(clang-analyzer-deadcode.DeadStores)
__if_exists(SQLite3::CDB::SetLastInsertRowID)
{
  db.SetLastInsertRowID(42);
  nnValue = db.LastInsertRowID(); //NOLINT(clang-analyzer-deadcode.DeadStores)
} //__if_exists(SQLite3::CDB::SetLastInsertRowID)
  nRet = db.Limit(SQLITE_LIMIT_LENGTH, 1024); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nRet = db.GetAutocommit(); //NOLINT(clang-analyzer-deadcode.DeadStores)

  nRet = db.Exec("SELECT b, c FROM a;"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nValue = db.ErrorCode(); //NOLINT(clang-analyzer-deadcode.DeadStores)
__if_exists(SQLite3::CDB::SystemErrno)
{
  nValue = db.SystemErrno(); //NOLINT(clang-analyzer-deadcode.DeadStores)
} //__if_exists(SQLite3::CDB::SystemErrno)
  nValue = db.ExtendedErrorCode(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nRet = db.DeclareVirtualTable("tblVirtual"); //NOLINT(clang-analyzer-deadcode.DeadStores)
__if_exists(SQLite3::CDB::TxnState)
{
  nValue = db.TxnState("main"); //NOLINT(clang-analyzer-deadcode.DeadStores)
} //__if_exists(SQLite3::CDB::TxnState)

__if_exists(SQLite3::CDB::GetClientData)
{
  void* pDoesNotExist = db.GetClientData("DoesNotExist");
  UNREFERENCED_PARAMETER(pDoesNotExist);
  assert(pDoesNotExist == nullptr);
  const char* pszPointerName = "DoesExist";
  const char* pszPointerValue = "42";
#pragma warning(suppress: 26492)
  db.SetClientData(pszPointerName, const_cast<char*>(pszPointerValue), nullptr);
  void* pDoesExist = db.GetClientData(pszPointerName);
  UNREFERENCED_PARAMETER(pDoesExist);
  assert(pDoesExist != nullptr);
  assert(pDoesExist == pszPointerValue);
} //__if_exists(SQLite3::CDB::GetClientData)

  nRet = db.OverloadFunction("PJFUN", 1); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);

  nRet = db.DBReadOnly("main"); //NOLINT(clang-analyzer-deadcode.DeadStores)
  const char* pzDataType{nullptr};
  const char* pzCollSeq{nullptr};
  int NotNull{0};
  int PrimaryKey{0};
  int Autoinc{0};
  nRet = db.TableColumnMetadata("main", "a", "b", &pzDataType, &pzCollSeq, &NotNull, &PrimaryKey, &Autoinc); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
  nRet = db.DBReleaseMemory(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
  const sqlite3_mutex* pMutex{db.DBMutex()};
  UNREFERENCED_PARAMETER(pMutex);
  sqlite3_filename szTemp{db.DBFilename("main")}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)

  int nCurValue{0};
  int nHWValue{0};
  nRet = db.DBStatus(SQLITE_DBSTATUS_CACHE_USED, &nCurValue, &nHWValue, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);

  SQLite3::CValue2 value;
  nRet = db.Exec16Scalar(L"SELECT NULL", value); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_ROW);
  SQLite3::CValue2 value7;
__if_exists(SQLite3::CDB::ExecScalarv3)
{
  nRet = db.ExecScalarv3("SELECT NULL", value7, SQLITE_PREPARE_PERSISTENT); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_ROW);
} //__if_exists(SQLite3::CDB::ExecScalarv3)
__if_exists(SQLite3::CValue::NoChange)
{
  const int nNoChange{value7.NoChange()};
  UNREFERENCED_PARAMETER(nNoChange);
} //__if_exists(SQLite3::CValue::NoChange)
__if_exists(SQLite3::CValue::FromBind)
{
    const int nFromBind{value7.FromBind()};
    UNREFERENCED_PARAMETER(nFromBind);
} //__if_exists(SQLite3::CValue::NoChange)
__if_exists(SQLite3::CValue::VTabInFirst)
{
  SQLite3::CValue tab1;
#pragma warning(suppress: 26486)
  value7.VTabInFirst(tab1);
} //__if_exists(SQLite3::CValue::VTabInFirst)
__if_exists(SQLite3::CValue::VTabInNext)
{
  SQLite3::CValue tab2;
#pragma warning(suppress: 26486)
  value7.VTabInNext(tab2);
} //__if_exists(SQLite3::CValue::VTabInNext)
  const void* pValue{value.Blob()}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
  int nBytes{value.Bytes()}; //NOLINT(clang-analyzer-deadcode.DeadStores)
  nBytes = value.Bytes16(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  double fDouble{value.Double()}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
  nValue = value.Int(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nnValue = value.Int64(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  int nType{value.Type()}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
  int nNumericType{value.NumericType()}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
  const unsigned char* pszText{value.Text()}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
  wprintf(L"%s\n", value.Text16());
#endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
  nRet = db.Exec16Scalar(L"SELECT 563", value); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_ROW);
  pValue = value.Blob(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nBytes = value.Bytes(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nBytes = value.Bytes16(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  fDouble = value.Double(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nValue = value.Int(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nnValue = value.Int64(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nType = value.Type(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nNumericType = value.NumericType(); //NOLINT(clang-analyzer-deadcode.DeadStores)
__if_exists(SQLite3::CValue2::Subtype)
{
  const unsigned int nSubType{value.Subtype()};
  UNREFERENCED_PARAMETER(nSubType);
} //__if_exists(SQLite3::CValue2::Subtype)
__if_exists(SQLite3::CValue::Encoding)
{
  const int nEncoding{value.Encoding()};
  UNREFERENCED_PARAMETER(nEncoding);
} //__if_exists(SQLite3::CValue::Encoding)
  pszText = value.Text(); //NOLINT(clang-analyzer-deadcode.DeadStores)
#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
  wprintf(L"%s\n", value.Text16());
#endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT

__if_exists(SQLite3::CValue2::Duplicate)
{
  SQLite3::CValue value6{value.Duplicate()};
  //value6.Free();
} //__if_exists(SQLite3::CValue2::Duplicate)
__if_exists(SQLite3::CValue2::Pointer)
{
  void* pPointer{value.Pointer("unknown")};
  UNREFERENCED_PARAMETER(pPointer);
} //__if_exists(SQLite3::CValue2::Pointer)

  SQLite3::CValue2 value2;
  SQLite3::CValue2 value3;

  SQLite3::CStatement stm2;

  SQLite3::CPtr sSQL;
  const char* zText{"It's a happy day!"};
  sSQL.Format("INSERT INTO a VALUES('%q', 'other text')", zText);
  nRet = db.Exec(sSQL); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
  SQLite3::CPtr x;
  SQLite3::CPtr y;
  y.m_bAutoFree = true;
  y.Allocate(12);
  y.Reallocate(3);
  y.Free();
  y.Allocate64(42);
  y.Reallocate64(43);

  nValue = db.Changes(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  nValue = db.TotalChanges(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  const sqlite3_int64 nnValue2{db.TotalChanges64()}; //NOLINT(clang-analyzer-deadcode.DeadStores)
  UNREFERENCED_PARAMETER(nnValue2);
  nRet = db.BusyTimeout(1000); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);
  nRet = db.EnableLoadExtension(1); //NOLINT(clang-analyzer-deadcode.DeadStores)
  assert(nRet == SQLITE_OK);

  {
    nRet = db.ExtendedResultCodes(1); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);

    db.Exec("CREATE TABLE b (fldText TEXT);");
    nRet = db.Exec("INSERT INTO b VALUES('Mary had a Little Lamb');"); //NOLINT(clang-analyzer-deadcode.DeadStores)
    nRet = db.Exec("INSERT INTO b VALUES('Mary had a Little Lamb 2');"); //NOLINT(clang-analyzer-deadcode.DeadStores)
    nRet = db.Exec("INSERT INTO b VALUES('Mary had a Little Lamb 3');"); //NOLINT(clang-analyzer-deadcode.DeadStores)

    SQLite3::CBlob blob;
#pragma warning(suppress: 26486)
    nRet = blob.Open(db, "main", "b", "fldText", 1, 1); //NOLINT(clang-analyzer-deadcode.DeadStores)
    const char* szErr{db.ErrorMessage()};
    UNREFERENCED_PARAMETER(szErr);
    const void* szErr2{db.ErrorMessage16()};
    UNREFERENCED_PARAMETER(szErr2);
    assert(nRet == SQLITE_OK);
    nBytes = blob.Bytes();
    SQLite3::CPtr ptr;
    ptr.Allocate(nBytes);
    nRet = blob.Read(ptr, nBytes, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);
    nRet = blob.Write(ptr, nBytes, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);
    nRet = blob.Reopen(3); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);

    SQLite3::CBlob blob2{blob, false};
    SQLite3::CBlob blob3;

    blob2.Detach();
    blob2.Attach(blob3.Detach(), false);

    const sqlite3_blob* pBlob{blob2};
    UNREFERENCED_PARAMETER(pBlob);
    SQLite3::CBlob blob4(blob.Detach(), true);
  }

  {
    SQLite3::CStatement statement;
    nRet = statement.Prepare(db, "SELECT b, c FROM a;"); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);
    statement.Finalize();
    nRet = statement.Preparev2(db, "SELECT b, c FROM a;"); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);
    statement.Finalize();
    nRet = statement.Prepare16(db, L"SELECT b, c FROM a;"); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);
    statement.Finalize();
    nRet = statement.Prepare16v2(db, L"SELECT b, c FROM a;"); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);
  __if_exists(SQLite3::CStatement::Prepare16v3)
  {
    SQLite3::CStatement statement2;
    nRet = statement2.Prepare16v3(db, L"SELECT b, c FROM a;", SQLITE_PREPARE_PERSISTENT); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);
  } //__if_exists(SQLite3::CStatement::Prepare16v3)
    const char* pZerr{db.ErrorMessage()};
    UNREFERENCED_PARAMETER(pZerr);
    assert(nRet == SQLITE_OK);
    const int nColumns{statement.ColumnCount()};
  #ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
    for (int i=0; i<nColumns; i++)
    {
      wprintf(L"%s|", statement.ColumnName16(i));
    }
    wprintf(L"\n");
  #endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT

    szTemp = statement.ColumnDatabaseName(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    const void* szTemp2{statement.ColumnDatabaseName16(0)}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
    szTemp = statement.ColumnTableName(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    szTemp2 = statement.ColumnTableName16(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    szTemp = statement.ColumnOriginName(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    szTemp2 = statement.ColumnOriginName16(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    szTemp = statement.ColumnDecltype(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    szTemp2 = statement.ColumnDecltype16(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    szTemp2 = statement.ColumnBlob(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    nBytes = statement.ColumnBytes(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    nBytes = statement.ColumnBytes16(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    const double dbl = statement.ColumnDouble(0);
    UNREFERENCED_PARAMETER(dbl);
    nValue = statement.ColumnInt(0);
    UNREFERENCED_PARAMETER(nValue);
    nnValue = statement.ColumnInt64(0);
    UNREFERENCED_PARAMETER(nnValue);
    const unsigned char* szTemp3{statement.ColumnText(0)};
    UNREFERENCED_PARAMETER(szTemp3);
    szTemp2 = statement.ColumnText16(0); //NOLINT(clang-analyzer-deadcode.DeadStores)
    szTemp = statement.SQL(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  __if_exists(SQLite3::CStatement::ExpandedSQL)
  {
    char* pSQL{statement.ExpandedSQL()};
    sqlite3_free(pSQL);
  } //__if_exists(SQLite3::CStatement::ExpandedSQL)
    const int nReadOnly{statement.ReadOnly()};
    UNREFERENCED_PARAMETER(nReadOnly);
    const int nBusy{statement.Busy()};
    UNREFERENCED_PARAMETER(nBusy);
  __if_exists(SQLite3::CStatement::IsExplain)
  {
    const int nExplain{statement.IsExplain()};
    UNREFERENCED_PARAMETER(nExplain);
  } //__if_exists(SQLite3::CStatement::IsExplain)

  __if_exists(SQLite3::CStatement::IsExplain)
  {
   const int nExplain2 = statement.Explain(3);
   UNREFERENCED_PARAMETER(nExplain2);
  } //__if_exists(SQLite3::CStatement::IsExplain)

    SQLite3::CStatement stmt1;
#pragma warning(suppress: 26486)
    while (db.NextStatement(stmt1))
    {
      szTemp = stmt1.SQL(); //NOLINT(clang-analyzer-deadcode.DeadStores)
    }

    //db.Interrupt();
  __if_exists(SQLite3::CDB::IsInterrupted)
  {
    const int bInterrupted = db.IsInterrupted();
    UNREFERENCED_PARAMETER(bInterrupted);
  }

    int nResult{statement.Step()};
    while (nResult == SQLITE_ROW)
    {
      const int nColumnsThisRow{statement.DataCount()};
      UNREFERENCED_PARAMETER(nColumnsThisRow);
      for (int i=0; i<nColumns; i++)
      {
        SQLite3::CValue value4{statement.ColumnValue(i)};
      #ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
        wprintf(L"%s|", value4.Text16());
      #endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
      }
      wprintf(L"\n");

      //Move to the next row
      nResult = statement.Step();
    }


    {
      //Lets try some parameter binding by index
      SQLite3::CStatement stmt3;
      nRet = stmt3.Prepare16v2(db, L"INSERT INTO a VALUES(?, ?)"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);

      nRet = stmt3.ParameterCount(); //NOLINT(clang-analyzer-deadcode.DeadStores)
      szTemp = stmt3.ParameterName(1); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt3.ParameterIndex("doesNotExist"); //NOLINT(clang-analyzer-deadcode.DeadStores)

      nRet = stmt3.Bind16(1, L"blob value"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt3.Bind16("A Name", L"blob value"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt3.Bind("A Name", "blob value"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt3.BindZeroBlob(1, 12); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt3.Bind(1, "string value"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
#pragma warning(suppress: 26477)
      nRet = stmt3.Bind64(1, "string value", 12, SQLITE_STATIC); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
#pragma warning(suppress: 26477)
      nRet = stmt3.Bind("A Name", "string value", 12, SQLITE_STATIC); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt3.Bind(1, 123456789123); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt3.BindNULL(1); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt3.Bind(1, 1); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt3.Bind(2, "blob value", 10); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
    __if_exists(SQLite3::CStatement::BindPointer)
    {
#pragma warning(suppress: 26492 26490)
      nRet = stmt3.BindPointer(2, const_cast<void*>(reinterpret_cast<const void*>("data")), "demo", DestructorCallback); //NOLINT(clang-analyzer-deadcode.DeadStores)
    } //__if_exists(SQLite3::CStatement::BindPointer)
      assert(nRet == SQLITE_OK);
      nRet = stmt3.Bind(2, 3.4); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt3.Step(); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_DONE);
    }

    {
      //Lets try some parameter binding by name
      SQLite3::CStatement stmt4;
      nRet = stmt4.Prepare16v2(db, L"INSERT INTO a VALUES(:param1, :param2)"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);

      nRet = stmt4.ParameterCount(); //NOLINT(clang-analyzer-deadcode.DeadStores)
      szTemp = stmt4.ParameterName(1); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt4.ParameterIndex("doesNotExist"); //NOLINT(clang-analyzer-deadcode.DeadStores)

      nRet = stmt4.Bind16(":param1", L"blob value"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt4.BindZeroBlob(1, 12); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt4.BindZeroBlob(":param1", 12); //NOLINT(clang-analyzer-deadcode.DeadStores)
    __if_exists(SQLite3::CStatement::BindZeroBlob64)
    {
      nRet = stmt4.BindZeroBlob64(1, 12); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt4.BindZeroBlob64(":param1", 12); //NOLINT(clang-analyzer-deadcode.DeadStores)
    } //__if_exists(SQLite3::CStatement::BindZeroBlob64)
      nRet = stmt4.Bind(":param1", "string value"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt4.Bind(":param1", 123456789123); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt4.BindNULL(":param1"); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt4.Bind(":param1", 1); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      nRet = stmt4.Bind(":param2", "blob value", 10); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt4.Bind(":param2", static_cast<const void*>("blob value"), 10); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt4.Bind64(":param2", static_cast<const void*>("blob value"), 10); //NOLINT(clang-analyzer-deadcode.DeadStores)
      nRet = stmt4.Bind(":param2", 3.4); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_OK);
      assert(nRet == SQLITE_OK);
      nRet = stmt4.Step(); //NOLINT(clang-analyzer-deadcode.DeadStores)
      assert(nRet == SQLITE_DONE);
    }

    //Try STL style iterator support
    {
      SQLite3::CRowset2 rowset;
      nRet = db.ExecRowset16(L"SELECT b, c FROM a;", rowset); //NOLINT(clang-analyzer-deadcode.DeadStores)
      for (SQLite3::CRowset::iterator i=rowset.begin(); i<rowset.end(); ++i)
      {
        SQLite3::CRow& row{*i};
        const SQLite3::CRow& crow{*i};

        wprintf(L"Current row using CRow::iterator\n");
        for (SQLite3::CRow::iterator j=row.begin(); j<row.end(); ++j)
        {
          const SQLite3::CValue& value4{*j};
        #ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
          wprintf(L"%s|", value4.Text16());
        #else
          UNREFERENCED_PARAMETER(value4);
        #endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
        }
        wprintf(L"\n");

        wprintf(L"Current row using CRow::operator[]\n");
        for (const auto& r : row)
        {
        #ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
          wprintf(L"%s|", r.Text16());
        #endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
          UNREFERENCED_PARAMETER(r);
        }
        wprintf(L"\n");

        wprintf(L"Current row using CRow::reverse_iterator\n");
        for (SQLite3::CRow::reverse_iterator s=row.rbegin(); s<row.rend(); ++s)
        {
          const SQLite3::CValue& value4{*s};
        #ifdef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
          UNREFERENCED_PARAMETER(value4);
        #else
          wprintf(L"%s|", value4.Text16());
        #endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
        }
        wprintf(L"\n");

        const SQLite3::CRow::const_reverse_iterator u1{crow.crbegin()}; //NOLINT(clang-diagnostic-unused-variable)
        UNREFERENCED_PARAMETER(u1);
        const SQLite3::CRow::const_reverse_iterator u2{crow.crend()};
        const SQLite3::CRow::const_reverse_iterator u3{u2}; //NOLINT(clang-diagnostic-unused-variable)
        SQLite3::CRow::const_reverse_iterator u4;
        u4 = u2;

        SQLite3::CRow::difference_type nValue2{std::distance(crow.begin(), crow.end())}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
        nValue2 = std::distance(crow.end(), crow.begin()); //NOLINT(clang-analyzer-deadcode.DeadStores)
        nValue2 = std::distance(crow.rbegin(), crow.rend()); //NOLINT(clang-analyzer-deadcode.DeadStores)
        nValue2 = std::distance(crow.rend(), crow.rbegin()); //NOLINT(clang-analyzer-deadcode.DeadStores)
        nValue2 = std::distance(u4, crow.crend()); //NOLINT(clang-analyzer-deadcode.DeadStores)

        SQLite3::CRow::reverse_iterator u7{row.rend()};
        assert(u7.base() == row.begin());
        std::advance(u7, 2);

        const SQLite3::CRow::const_reverse_iterator u8{row.crend()}; //NOLINT(clang-diagnostic-unused-variable)
        assert(u8.base() == crow.cbegin());
        UNREFERENCED_PARAMETER(u8);

        SQLite3::CRow::const_iterator u5{crow.begin()};
        std::advance(u5, 1);
        const SQLite3::CValue& value5{*u5};
        UNREFERENCED_PARAMETER(value5);

        wprintf(L"Current row using CRow::const_iterator\n");
        for (SQLite3::CRow::const_iterator u6=crow.cbegin(); u6<crow.cend(); ++u6)
        {
          const SQLite3::CValue& value4{*u6};
        #ifdef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
          UNREFERENCED_PARAMETER(value4);
        #else
          wprintf(L"%s|", value4.Text16());
        #endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
        }
        wprintf(L"\n");

        wprintf(L"Current row using CRow::const_reverse_iterator\n");
        for (SQLite3::CRow::const_reverse_iterator u=crow.crbegin(); u<crow.crend(); ++u)
        {
          const SQLite3::CValue& value4{*u};
        #ifdef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
          UNREFERENCED_PARAMETER(value4);
        #else
          wprintf(L"%s|", value4.Text16());
        #endif //#ifndef SQLITE3WRAPPERS_NO_WCHAR_T_SUPPORT
        }
        wprintf(L"\n");
      }
    }

    SQLite3::CDB db5{statement.DB()};
    nRet = statement.ClearBindings(); //NOLINT(clang-analyzer-deadcode.DeadStores)
    assert(nRet == SQLITE_OK);
  __if_exists(SQLite3::CDB::CacheFlush)
  {
    nRet = db.CacheFlush(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  } //__if_exists(SQLite3::CDB::CacheFlush)

  __if_exists(SQLite3::CDB::DropModules)
  {
    nRet = db.DropModules(nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)
  } //__if_exists(SQLite3::CDB::DropModules)

  __if_exists(SQLite3::CDB::ErrorOffset)
  {
    nValue = db.ErrorOffset(); //NOLINT(clang-analyzer-deadcode.DeadStores)
  } //__if_exists(SQLite3::CDB::ErrorOffset)

  __if_exists(SQLite3::CDB::DBName)
  {
    auto name = db.DBName(0); //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
    name = db.DBName(1); //NOLINT(clang-analyzer-deadcode.DeadStores)
  } //__if_exists(SQLite3::CDB::DBName)


  }

  return 0;
}
